%% BMP2JPEG(fig_bitmap,modo)
% Faz a converso da figura FIG_BITMAP para o padro jpeg.
% O valor de MODO, indica a converso a ser realizada
function fig_jpeg = BMP2JPEG(fig_bitmap,modo)

%% MODO = NADA
% No modo "nada", nenhuma converso  realizada, apenas a matriz 
% convertida em um vetor para ser transmitido na serial.
if strcmpi(modo,'nada')
    
    % Pega o tamanho da imagem
    tam = size(fig_bitmap);
    % Aloca memria para a imagem jpeg
    fig_jpeg = zeros(1,tam(1)*tam(2)*tam(3),'uint8');
    % "i" indexa toda a imagem
    i = 1 : tam(1)*tam(2)*tam(3);
    % Converte a matriz da figura BMP para um vetor 
    fig_jpeg(i) = fig_bitmap(i);

%% MODO = HD
% No modo "hd", a converso  realizada, porm, utilizando o chuncho da
% gravao no HD e leitura de arquivo binrio.
elseif strcmpi(modo,'hd')

    % Grava a imagem no HD como JPEG
    imwrite(fig_bitmap,'Imagem.jpg','jpeg');
    % Abre o arquivo como binrio
    fid = fopen('Imagem.jpg', 'r');
    % L a imagem
    fig_jpeg = fread(fid);
    % Encerra o descritor para o arquivo
    fclose(fid);
 
end