%% Codificao de vdeo e transmisso via porta serial
%
% Neste trabalho, uma continuao do relatrio *Mtodos de aquisio de
% vdeo*, a imagem capturada da _webcam_ ser transformada em *JPEG*, afim
% de reduzir a banda necessria  sua transmisso; e transmitida pela porta
% serial  outro computador.
%
% Neste trabalho, realizaremos um estudo dos mtodos de captura de vdeo no
% MatLab. Ele pertence  atividade 1 e 2 da primeira meta do projeto final
% *Transmisso de Vdeo para uma unidade mvel via EDGE*.
%
clear all
profile on;
% Adicionando o caminho para as outras funes do trabalho.
addpath ..;

%% Configurando a aquisio do vdeo
% Usamos a script ConfiguraCamera.m para fazer a configurao dos
% parmetros da captura
ConfiguraCamera;

%% Configurando a porta serial
% Usamos a script ConfiguraSerial.m para a configurao da porta serial
ConfiguraSerial;

%% Configurando trmino da captura do vdeo
% Tecla a ser pressionada para interrupo da captura
defaultKey = 'q';
deadKey = char(1);
% Usa-se uma figura para monitorar o pressionamento da tecla defaultKey.
% Aqui, configuramos a figura:
% hf = figure('Tag','KEY_CATCHER', ...
%         'Units','Normalized','Position',[1.1 1.1 .2 .1], ...
%         'Menubar','None','CurrentCharacter',deadKey, ...
%         'IntegerHandle','On','NumberTitle','Off', ...
%         'Name','EDGE2JAVA','Resize','on', ...
%         'HandleVisibility','off');
% Ativa a figura
hf = figure(1);

set(hf,'Tag','KEY_CATCHER', ...
        'Units','Normalized','Position',[1.1 1.1 .2 .1], ...
        'Menubar','None','CurrentCharacter',deadKey, ...
        'IntegerHandle','On','NumberTitle','Off', ...
        'Name','EDGE2JAVA','Resize','on', ...
        'HandleVisibility','on');
title('Aperte "q" para sair...')
drawnow

%% Iniciando a captura
% Aps o comando start(<objeto>), inicia-se a captura do vdeo. Os quadros
% sero postos no espao de memria utilizado pelo Image Acquisition Toolbox
start(objeto);
% Iniciamos tambm a comunicao com a porta serial do PC
fopen(serialUm)

% Enviando ao outro lado as informaes de tamanho da imagem
fprintf(serialUm,altura);
fprintf(serialUm,largura);
fprintf(serialUm,cores/8);

%% Captura do vdeo
% Capturaremos o vdeo e enviaremos  serial

% Criamos um loop infinito
display('Selecione a figura e aperte a tecla "q" para sair.')
while true;

    % D o start  captura do vdeo
    trigger(objeto);
    % Pega o frame da memria
    data = getdata(objeto);
    
    % Converte para jpeg
    datajpeg = BMP2JPEG(data,'hd');
    
    % Envia o vetor ao outro lado
    fprintf(serialUm,datajpeg);
    
    % Libera a memria
    flushdata(objeto);
    % Atrasa um tempo
    pause(0.25);
     
    % V se foi pressionada a tecla de parada
    cc = get(hf,'CurrentCharacter');
    if strcmpi(cc,defaultKey)
        break;
    end
    
end

%% Liberando as instncias
stop(objeto);
flushdata(objeto);
delete(serialUm);
close(hf);